'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 30 April 2023 at 9:53:42 am'!
DividedImageFrameMorph subclass: #ScratchScriptEditorMorph
	instanceVariableNames: 'thumbnailMorph nameMorph pageViewerMorph rotationButtons lockButton readoutMorphs penReadout currentCategory tabPaneMorph deleteButton stopButton goButton '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-UI-Panes'!

!ScratchFrameMorph methodsFor: 'microwitch'!
sendMicroPythonScript
	| script code |
	self currentHatBlocks isEmpty ifTrue: [^ self].
	self hasDuplicateHatBlocks ifTrue: [^ DialogBoxMorph inform: 'has duplicate hat blocks.' localized].
	mpboard isConnecting ifFalse: [self connectMicrobit].
	mpboard isConnecting ifFalse: [^ self].
	self stopAll.
	code := MicrobitCode new newlineCR.
	script := code pythonScriptFrom: self currentHatBlocks stageMorph: workPane.
	self uploadExternalModules: code externalModules.
	mpboard write: script fileNamed: 'main.py'.
	mpboard show: 'ok'.
	mpboard reboot! !


!ScratchScriptEditorMorph methodsFor: 'initialization'!
createTabPane

	| tabOnForm tabOffForm tabID tabLabel |

	"create tab pane"
	tabPaneMorph := ScratchTabPaneMorph new.
	tabPaneMorph
		borderWidth: 0;
		color: Color transparent;
		targetPane: self.

	tabOnForm := (ScratchFrameMorph skinAt: #tabOn).
	tabOffForm := (ScratchFrameMorph skinAt: #tabOff).

	"add the tabs"
	#(Scripts) do: [:spec |
		tabID := spec asString.
		tabLabel := tabID localized.
		tabPaneMorph
			createTab: tabID
			withLabel: tabLabel
			onForm: tabOnForm
			offForm: tabOffForm].

	"set current tab and add to frame"
	tabPaneMorph currentTab: 'Scripts'.
	"self addMorph: tabPaneMorph."
! !

!ScratchScriptEditorMorph methodsFor: 'initialization'!
initialize

	super initialize.
	self
		initFrontFromForm: (ScratchFrameMorph skinAt: #spriteLibraryPaneFrameTransparent2)
		topSectionHeight: 90.
	self middleBarLeftMargin: 0 rightMargin: 6.
	self color: (Color r: (149/255) g: (154/255) b: (159/255)).

	thumbnailMorph _ self createThumbnailMorph.
	self addMorph: (thumbnailMorph position: self position + (37@16)).

	self addNameBox.
	self addGoButton.
	self addStopButton.

	pageViewerMorph _ ScrollFrameMorph2 new
		growthFraction: 0.1;
		color: ScratchFrameMorph scriptsPaneColor.
	self addMorph: (pageViewerMorph position: (self left @ (self top + topSectionHeight))).

	readoutMorphs _ #().
	self target: nil.
	thumbnailMorph extent: 50@50.
	self extent: 300@400.
	self createTabPane.
! !

!ScratchScriptEditorMorph methodsFor: 'accessing'!
bareMinimumWidth
	"Answer the bare minimum width for this pane to be useable."

	^ stopButton right - self left! !

!ScratchScriptEditorMorph methodsFor: 'drawing'!
fullDrawOn: aCanvas
	"Draw my frame in front of my submorphs."

	| clipC |
	self isHidden ifTrue: [^ self].
	(self hasProperty: #errorOnDraw) ifTrue:[^ self drawErrorOn: aCanvas].
	(aCanvas isVisible: self fullBounds) ifFalse: [^ self].

	"myBox has integer position and extent and has a potentially inset bottom"
	myBox _ bounds truncated.
	clipC _ aCanvas copyClipRect: myBox.

	frameInFront
		ifTrue: [
			self drawOn: clipC.
			self drawSubmorphsOn: clipC.
			self drawFrameOn: clipC.
			"aCanvas fullDrawMorph: tabPaneMorph"]
		ifFalse: [
			self drawOn: clipC.
			self drawSubmorphsOn: clipC].
! !

!ScratchScriptEditorMorph methodsFor: 'geometry'!
fixLayout
	| p x y h lines gap |

	goButton position: thumbnailMorph right + 10 @ (thumbnailMorph top + (thumbnailMorph height - stopButton height / 2)).

	stopButton position: (goButton right + 10) @ goButton top.

	p := (stopButton right + 10) @ (thumbnailMorph top).
	"layout readout morphs"
	readoutMorphs size > 0
		ifTrue: 
			[lines _ readoutMorphs size // 2.
			h _ readoutMorphs inject: 0 into: [:prev :each | prev max: each height].
			gap _ thumbnailMorph height - (lines * h) // (lines + 1).
			x _ p x.
			y _ p y + gap.
			readoutMorphs
				pairsDo: 
					[:m1 :m2 | 
					m1 position: p x @ y.
					m2 top: y.
					y _ y + h + gap.
					x _ x max: m1 right].
			x _ x + 10.
			readoutMorphs pairsDo: [:m1 :m2 | m2 left: x]].
	"layout lock and pen morphs"
	"place tab morph"
	readoutMorphs size > 1 ifTrue: [topSectionHeight _ thumbnailMorph height + tabPaneMorph height + 15].
	tabPaneMorph width: self width;
	 position: self left + 15 @ (self top + topSectionHeight - tabPaneMorph height + 1).
	"place scripts scroll pane"
	pageViewerMorph position: self left @ (self top + topSectionHeight).
	self extent: self extent! !

!ScratchScriptEditorMorph methodsFor: 'private'!
addReadouts
	"Add readouts for my target's position and direction."

	| x y label readout s sFrame |
	self deleteReadouts.
	readoutMorphs _ OrderedCollection new.
	sFrame _ self ownerThatIsA: ScratchFrameMorph.

	x _ thumbnailMorph left.
	y _ thumbnailMorph bottom + 5.

	#(('port' portName) ('status' currentStatus)) do: [:spec |

		(ScratchTranslator isRTL and: [(spec at: 1) = 'x' or: [(spec at: 1) = 'y']])
			ifTrue: [s _ (':', spec first) asUTF8]
			ifFalse: [s _ (spec first localized, ScratchTranslator colonSuffix)].

		label _ StringMorph new
			contents: s;
			font: (ScratchFrameMorph getFont: #XYReadout);
			position: x@y.

		readout _ (UpdatingStringMorph on: sFrame selector: spec second)
			font: (ScratchFrameMorph getFont: #XYReadoutBold);
			forceUnicodeRendering: true;
			color: (Color gray: 0.2);
			contents: '0000000000000000';  "this sets the readout size"
			growable: false;
			stepTime: 100;
			position: (label right + 4)@y.

		ScratchTranslator isRTL ifTrue:[
			readout rightJustify: true].

		self addMorph: label; addMorph: readout.
		readoutMorphs add: label; add: readout.

		readout startStepping.
		x _ readout right + 2].

	ScratchTranslator isRTL ifTrue: [
		readoutMorphs reversed do: [: m |
			readoutMorphs remove: m.
			readoutMorphs add: m]].

	readoutMorphs _ readoutMorphs asArray.
! !

!ScratchScriptEditorMorph methodsFor: 'private'!
showOrHideReadouts
	"If this is a sprite, show the position and direction readouts and the rotation style buttons. Otherwise, hide them."

	self deleteReadouts.

	"nameMorph
		font: nameMorph font;
		width: nameMorph height * 4;
		rightJustify: ScratchTranslator isRTL."

	(self target isKindOf: ScratchSpriteMorph) ifTrue: [
		self addReadouts.
		World ifNotNil: [World startSteppingSubmorphsOf: self]].
! !

!ScratchScriptEditorMorph methodsFor: 'microwitch'!
addGoButton
	"Add button to start script."
	goButton := ToggleButton onForm: (ScratchFrameMorph skinAt: #goButton)
				offForm: (ScratchFrameMorph skinAt: #goButtonPressed).
	goButton target: self;
	 actionSelector: #go;
	 setBalloonText: 'Start green flag scripts' localized;
	 actWhen: #buttonUp;
	 isMomentary: true;
	 position: thumbnailMorph right + 4 @ (thumbnailMorph top + (thumbnailMorph height - goButton height / 2)).
	self addMorph: goButton! !

!ScratchScriptEditorMorph methodsFor: 'microwitch'!
addStopButton
	"Add button to stop running script."
	stopButton := ToggleButton onForm: (ScratchFrameMorph skinAt: #stopButton)
				offForm: (ScratchFrameMorph skinAt: #stopButtonPressed).
	stopButton target: self;
	 actionSelector: #stop;
	 setBalloonText: 'Stop everything' localized;
	 actWhen: #buttonUp;
	 isMomentary: true;
	 position: thumbnailMorph right + 4 @ (thumbnailMorph top + (thumbnailMorph height - stopButton height / 2)).
	self addMorph: stopButton! !

!ScratchScriptEditorMorph methodsFor: 'microwitch' stamp: 'EiichiroIto 4/30/2023 09:39'!
go
	self frameMorph sendMicroPythonScript! !

!ScratchScriptEditorMorph methodsFor: 'microwitch' stamp: 'EiichiroIto 4/30/2023 09:40'!
stop
	self frameMorph stopAll! !

ScratchScriptEditorMorph removeSelector: #addDeleteButton!
ScratchScriptEditorMorph removeSelector: #addLockButton!
ScratchScriptEditorMorph removeSelector: #addRotationButtons!
ScratchScriptEditorMorph removeSelector: #deleteDeleteButton!
ScratchScriptEditorMorph removeSelector: #deleteLockButton!
ScratchScriptEditorMorph removeSelector: #deleteRotationButtons!
ScratchScriptEditorMorph removeSelector: #setRotationStyle:!
ScratchScriptEditorMorph removeSelector: #toggleSpriteDraggable!
ScratchScriptEditorMorph removeSelector: #updateLockButton!
ScratchScriptEditorMorph removeSelector: #updateRotationButtonHighlight!
DividedImageFrameMorph subclass: #ScratchScriptEditorMorph
	instanceVariableNames: 'thumbnailMorph nameMorph pageViewerMorph readoutMorphs currentCategory tabPaneMorph goButton stopButton '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-UI-Panes'!
