'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 30 March 2023 at 12:38:43 pm'!

!Morph methodsFor: 'accessing'!
frameMorph
	owner ifNil: [^ nil].
	^ owner frameMorph! !


!ScratchFrameMorph methodsFor: 'accessing' stamp: 'EiichiroIto 3/30/2023 10:38'!
frameMorph
	^ self! !

!ScratchFrameMorph methodsFor: 'microwitch'!
connectMicrobit
	| list menu selection path ver id firmware |
	scriptsPane thumbnailOff.
	list _ mpboard portNames sort.
	list isEmpty ifTrue: [^ DialogBoxMorph inform: 'no micro:bit found' localized].
	list size = 1
		ifTrue: [selection _ list first]
		ifFalse: 
			[menu _ CustomMenu new.
			list do: [:each | menu add: each action: each].
			selection _ menu startUp.
			selection ifNil: [^ self]].
	self connectPort: selection
		ifConnectedDo: 
			[scriptsPane thumbnailOn.
			^ self].
	path _ MicrowitchPlugin microbitDevice.
	path ifNil: [^ DialogBoxMorph inform: 'no micro:bit found' localized].
	id _ self getMicrobitIDFrom: path , FileDirectory pathNameDelimiter asString , 'DETAILS.TXT'.
	ver _ self microbitVersionForID: id.
	path _ path , FileDirectory pathNameDelimiter asString , 'firmware.hex'.
	firmware _ MicrobitCode firmwareFor: ver.
	firmware ifNil: [^ DialogBoxMorph inform: 'unable to find the appropriate firmware' localized].
	self writeString: firmware as: path.
	DialogBoxMorph inform: 'initializing micro:bit done, please re-send scripts' localized! !

!ScratchFrameMorph methodsFor: 'microwitch'!
disconnectMicrobit
	mpboard disconnect.
	scriptsPane thumbnailOff! !


!ScratchFrameMorph class methodsFor: 'class initialization'!
initialize
	"self initialize"

	Clipboard _ nil.
	WorkpaneExtent _ 480@360.
	UseErrorCatcher _ true.
	DefaultNotes _ ''.

	self initFonts.
	self readMicrobitForm
! !

!ScratchFrameMorph class methodsFor: 'microwitch'!
readMicrobitForm
	"ScratchFrameMorph readMicrobitForm"
	| dir form |
	dir := FileDirectory default directoryNamed: 'images'.
	form := Form fromFileNamed: (dir fullNameFor: 'connected.gif').
	ScratchFrameMorph skinAt: #connected put: form.
	form := Form fromFileNamed: (dir fullNameFor: 'disconnected.gif').
	ScratchFrameMorph skinAt: #disconnected put: form! !


!ScratchScriptEditorMorph methodsFor: 'initialization'!
initialize

	super initialize.
	self
		initFrontFromForm: (ScratchFrameMorph skinAt: #spriteLibraryPaneFrameTransparent2)
		topSectionHeight: 90.
	self middleBarLeftMargin: 0 rightMargin: 6.
	self color: (Color r: (149/255) g: (154/255) b: (159/255)).

	thumbnailMorph _ self createThumbnailMorph.
	self addMorph: (thumbnailMorph position: self position + (37@16)).

	self addNameBox.

	pageViewerMorph _ ScrollFrameMorph2 new
		growthFraction: 0.1;
		color: ScratchFrameMorph scriptsPaneColor.
	self addMorph: (pageViewerMorph position: (self left @ (self top + topSectionHeight))).

	rotationButtons _ #().
	readoutMorphs _ #().
	self target: nil.
	thumbnailMorph extent: 50@50.
	self extent: 300@400.
	self createTabPane.
! !

!ScratchScriptEditorMorph methodsFor: 'accessing'!
target: aScratchObjectOrNil
	"Start viewing the given object or no object."

	| sFrame nameSel |
	World activeHand newKeyboardFocus: nil.
	(aScratchObjectOrNil isNil or:
	 [aScratchObjectOrNil isScriptable not]) ifTrue: [
		"thumbnailMorph target: nil."
		nameMorph target: nil; contents: 'no object '.
		pageViewerMorph contents: (Morph new color: Color red).

		(sFrame _ self ownerThatIsA: ScratchFrameMorph) ifNotNil: [
			sFrame viewerPane target: nil].

		self showOrHideReadouts.
		^ self].

	"thumbnailMorph target: aScratchObjectOrNil."

	nameSel _ (aScratchObjectOrNil isKindOf: ScratchStageMorph)
		ifTrue: [nil]
		ifFalse: [#objName:].
	nameMorph
		target: aScratchObjectOrNil;
		getSelector: #objName;
		putSelector: nameSel.

	self showOrHideReadouts.
	self fixLayout.
! !

!ScratchScriptEditorMorph methodsFor: 'accessing' stamp: 'EiichiroIto 3/30/2023 10:45'!
thumbnailOff
	thumbnailMorph off! !

!ScratchScriptEditorMorph methodsFor: 'accessing' stamp: 'EiichiroIto 3/30/2023 10:46'!
thumbnailOn
	thumbnailMorph on! !

!ScratchScriptEditorMorph methodsFor: 'event handling'!
thumbnailClicked
	| frameMorph |
	frameMorph _ self frameMorph.
	frameMorph isConnecting
		ifTrue: 
			[frameMorph disconnectMicrobit]
		ifFalse: 
			[frameMorph connectMicrobit]! !

!ScratchScriptEditorMorph methodsFor: 'private'!
createThumbnailMorph
	^ ResizableToggleButton2 new padding: 0 @ 0;
	 offForm: (ScratchFrameMorph skinAt: #disconnected)
		onForm: (ScratchFrameMorph skinAt: #connected);
	 label: '' font: (ScratchFrameMorph getFont: #Button);
	 toggleButtonMode: true;
	 toggleMode: false;
	 actionSelector: #thumbnailClicked;
	 target: self;
	 extent: 48 @ 41;
	 yourself! !

ScratchFrameMorph initialize!
