'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 9 June 2023 at 2:00:31 pm'!

!ScratchFrameMorph methodsFor: 'startup'!
readSettingsFile
	"Read my settings file and answer a Dictionary of settings."
	"ScratchFrameMorph new readSettingsFile"

	| f dict s tokens k |
	f _ FileStream readOnlyFileNamedOrNil: self settingsFileName.
	f ifNil: [^ Dictionary new].
	dict _ Dictionary new.
	f contentsOfEntireFile lines do: [:line |
		s _ line collect: [:c | (c asciiValue < 32) ifTrue: [Character space] ifFalse: [c]].
		tokens _ s findTokens: '='.
		k _ tokens first withBlanksTrimmed asLowercase.
		tokens size = 2
			ifTrue: [dict at: k put: tokens second withBlanksTrimmed]
			ifFalse: [dict at: k put: '1']].
	^ dict
! !

!ScratchFrameMorph methodsFor: 'private'!
recordLanguage: aString
	"Record my language in the settings file."
	"ScratchFrameMorph new recordLanguage: 'English'"

	| fName f sz settings all |
	fName _ FileDirectory default fullNameFor: self settingsFileName.
	f _ FileStream concreteStream new open: fName forWrite: true.
	f ifNil: [^ self].
	sz _ f size.
	settings _ (f next: sz) lines.
	settings _ settings reject: [:s | s asLowercase beginsWith: 'language='].
	settings _ settings reject: [:s | all _ s asByteArray asSet. (all size = 1) and: [all asArray first = 0]].
	settings _ settings copyWith: ('Language=', aString).
	f position: 0.
	settings do: [:s | f nextPutAll: s, String crlf].
	[f position < sz] whileTrue: [f nextPut: 0 asCharacter].
	f close.
! !

!ScratchFrameMorph methodsFor: 'microwitch' stamp: 'EiichiroIto 6/9/2023 13:58'!
settingsFileName
	^ 'microwitch.ini'! !

