'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 18 January 2023 at 10:24:36 am'!
Object subclass: #MicroPythonBoard
	instanceVariableNames: 'port portName currentState response count requests returnValue interrupt useRaw useNormal '
	classVariableNames: 'PasteModeString PromptString UseAllPorts '
	poolDictionaries: ''
	category: 'MicroPython-Board'!

!MicroPythonBoard methodsFor: 'commands'!
write: aString fileNamed: aFilename 
	| cmd tmp |
	"Transcript cr; show: 'sending '; show: aFilename."
	cmd := 'f = open(''' , aFilename , ''', ''w'')'.
	self request: cmd.
	aString lines do: 
		[:each | 
		tmp := each copyReplaceAll: '''' with: '\'''.
		cmd := 'f.write(''' , tmp , '\n'')'.
		self request: cmd].
	cmd := 'f.close()'.
	self request: cmd.
	useNormal := true! !

!MicroPythonBoard methodsFor: 'initialize'!
initialize
	super initialize.
	currentState := #disconnect.
	requests := OrderedCollection new.
	response := ''.
	portName := ''.
	count := 0.
	useNormal := false! !

!MicroPythonBoard methodsFor: 'private'!
doSend
	self portIsOpen ifFalse: [^ self closePort].
	requests isEmpty
		ifTrue: 
			[interrupt = #reboot ifTrue: [self doReboot].
			^ self].
	self clearResponse.
	port flushInputBuffer.
	useNormal
		ifTrue: 
			[useNormal := false.
			self sendRequestUsingNormalMode]
		ifFalse: [self sendRequestUsingPasteMode].
	requests := OrderedCollection new.
	self setupRunning! !

!MicroPythonBoard methodsFor: 'private' stamp: 'EiichiroIto 1/18/2023 10:11'!
sendRequestUsingNormalMode
	'sending ...' localized
		displayProgressAt: Display boundingBox center
		with: requests
		during: 
			[:each | 
			port nextPutAll: each.
			port nextPut: 13.
			(Delay forMilliseconds: 100) wait.
			self processIncomingMessages]! !


!ScratchFrameMorph class methodsFor: 'microwitch'!
microwitchVersion
	^ '1.2.10'! !

Object subclass: #MicroPythonBoard
	instanceVariableNames: 'port portName currentState response count requests returnValue interrupt useNormal '
	classVariableNames: 'PasteModeString PromptString UseAllPorts '
	poolDictionaries: ''
	category: 'MicroPython-Board'!
