'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 30 March 2021 at 8:41:30 pm'!

!MicroPythonBoard methodsFor: 'private'!
doRunning
	interrupt = #stop ifTrue: [^ self doStop].
	self portIsOpen ifFalse: [^ self closePort].
	returnValue := self waitPromptFor: 0.
	returnValue
		ifNotNil: 
			[self setupReady].! !

!MicroPythonBoard methodsFor: 'private'!
waitPromptFor: anInteger 
	| ret timeout |
	self portIsOpen ifFalse: [^ nil].
	timeout := Time millisecondClockValue + anInteger.

	["(Delay forMilliseconds: 100) wait."
	self processIncomingMessages.
	ret := self parseResponse.
	ret ifNotNil: [^ ret withBlanksTrimmed].
	Time millisecondClockValue > timeout] whileFalse.
	^ nil! !


!ScratchFrameMorph methodsFor: 'menu/button actions'!
aboutScratch

	| dialogBox |
	self closeMediaEditorsAndDialogs ifFalse: [^ self].
	dialogBox := DialogBoxMorph new
		title: 'About micro:witch';
		withButtonsForYes: false no: false okay: true cancel: false.
	dialogBox
		message: 'micro:witch version 0.3
Copyright 2018 Eiichiro Ito.
All rights reserved.
https://github.com/EiichiroIto/microwitch

Based on Scratch from the MIT Media Lab, v', Version, '

Copyright  2009 Massachusetts Institute of Technology.
All rights reserved.
http://info.scratch.mit.edu/Source_Code
'
		font: (ScratchFrameMorph getFont: #AboutScratch).

	dialogBox getUserResponse.
! !

!ScratchFrameMorph methodsFor: 'microwitch'!
showPythonProgram
	| dialog script |
	self closeMediaEditorsAndDialogs ifFalse: [^ self].
	self hasDuplicateHatBlocks ifTrue: [^ DialogBoxMorph inform: 'has duplicate hat blocks.' localized].
	script := MicrobitCode new pythonScriptFrom: self currentHatBlocks stageMorph: workPane.
	dialog := MultilineTextDialog editFor: script.
	dialog getUserResponse! !

