'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 19 March 2020 at 5:12:53 pm'!
Object subclass: #MicroPythonBoard
	instanceVariableNames: 'port portName currentState response count requests returnValue interrupt useRaw '
	classVariableNames: 'PasteModeString PromptString '
	poolDictionaries: ''
	category: 'MicroPython-Board'!

!MicroPythonBoard methodsFor: 'commands'!
write: aString fileNamed: aFilename 
	| cmd tmp |
	cmd := 'f = open(''' , aFilename , ''', ''w'')'.
	self request: cmd.
	aString lines do: 
		[:each | 
		tmp := each copyReplaceAll: '''' with: '\'''.
		cmd := 'f.write(''' , tmp , '\n'')'.
		self request: cmd].
	cmd := 'f.close()'.
	self request: cmd.
	useRaw := true! !

!MicroPythonBoard methodsFor: 'initialize'!
initialize
	super initialize.
	currentState := #disconnect.
	requests := OrderedCollection new.
	response := ''.
	portName := ''.
	count := 0.
	useRaw := false! !

!MicroPythonBoard methodsFor: 'private'!
doSend
	self portIsOpen ifFalse: [^ self closePort].
	requests isEmpty
		ifTrue: 
			[interrupt = #reboot ifTrue: [self doReboot].
			^ self].
	self clearResponse.
	port flushInputBuffer.
	useRaw
		ifTrue: 
			[useRaw := false.
			self sendRequestUsingRawMode]
		ifFalse: [self sendRequestUsingPasteMode].
	requests := OrderedCollection new.
	self setupRunning! !

!MicroPythonBoard methodsFor: 'private'!
sendRequestUsingPasteMode
	(port nextPut: 5)
		= 0 ifTrue: [^ self closePort].
	requests do: 
		[:each | 
		port nextPutAll: each.
		port nextPut: 13.
		(Delay forMilliseconds: 100) wait.
		self processIncomingMessages].
	(port nextPut: 4)
		= 0 ifTrue: [^ self closePort]! !

!MicroPythonBoard methodsFor: 'private' stamp: 'EiichiroIto 3/19/2020 17:04'!
sendRequestUsingRawMode
	requests do: 
		[:each | 
		(port nextPut: 1)
			= 0 ifTrue: [^ self closePort].
		port nextPutAll: each.
		port nextPut: 13.
		(port nextPut: 4)
			= 0 ifTrue: [^ self closePort].
		(Delay forMilliseconds: 100) wait.
		port flushInputBuffer].
	(port nextPut: 2)
		= 0 ifTrue: [^ self closePort]! !

