'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 30 March 2023 at 2:58:44 pm'!

!ScratchScriptEditorMorph methodsFor: 'initialization'!
addNameBox

	nameMorph _ UpdatingStringFieldMorph new
		font: (ScratchFrameMorph getFont: #UpdatingStringField);
		rightJustify: ScratchTranslator isRTL;
		acceptWhenFocusLost: true;
		position: thumbnailMorph topRight + (17@(thumbnailMorph height * 0.12)).

	"self addMorphBack: nameMorph."! !

!ScratchScriptEditorMorph methodsFor: 'geometry'!
fixLayout
	| p x y h lines gap |
	p _ thumbnailMorph topRight + (17 @ 0).
	"layout readout morphs"
	readoutMorphs size > 0
		ifTrue: 
			[lines _ readoutMorphs size // 2.
			h _ readoutMorphs inject: 0 into: [:prev :each | prev max: each height].
			gap _ thumbnailMorph height - (lines * h) // (lines + 1).
			x _ p x.
			y _ p y + gap.
			readoutMorphs
				pairsDo: 
					[:m1 :m2 | 
					m1 position: p x @ y.
					m2 top: y.
					y _ y + h + gap.
					x _ x max: m1 right].
			x _ x + 10.
			readoutMorphs pairsDo: [:m1 :m2 | m2 left: x]].
	"layout lock and pen morphs"
	lockButton ifNotNil: [lockButton position: nameMorph right + 4 @ (nameMorph top + (nameMorph height - lockButton height / 2))].
	"place tab morph"
	readoutMorphs size > 1 ifTrue: [topSectionHeight _ thumbnailMorph height + tabPaneMorph height + 15].
	tabPaneMorph width: self width;
	 position: self left + 15 @ (self top + topSectionHeight - tabPaneMorph height + 1).
	"place scripts scroll pane"
	pageViewerMorph position: self left @ (self top + topSectionHeight).
	self extent: self extent! !

!ScratchScriptEditorMorph methodsFor: 'stepping'!
step

	currentCategory = 'Costumes' ifTrue: [self updateCostumeSelection].

	"(penReadout isNil or: [penReadout owner ~= self]) ifTrue: [^ self].
	self target penDown
		ifTrue: [penReadout color: self target penColor]
		ifFalse: [penReadout color: Color transparent]."
! !

!ScratchScriptEditorMorph methodsFor: 'private'!
addReadouts
	"Add readouts for my target's position and direction."

	| x y label readout s sFrame |
	self deleteReadouts.
	readoutMorphs _ OrderedCollection new.
	sFrame _ self ownerThatIsA: ScratchFrameMorph.

	x _ nameMorph left.
	y _ nameMorph bottom + 5.

	#(('port' portName) ('status' currentStatus)) do: [:spec |

		(ScratchTranslator isRTL and: [(spec at: 1) = 'x' or: [(spec at: 1) = 'y']])
			ifTrue: [s _ (':', spec first) asUTF8]
			ifFalse: [s _ (spec first localized, ScratchTranslator colonSuffix)].

		label _ StringMorph new
			contents: s;
			font: (ScratchFrameMorph getFont: #XYReadout);
			position: x@y.

		readout _ (UpdatingStringMorph on: sFrame selector: spec second)
			font: (ScratchFrameMorph getFont: #XYReadoutBold);
			forceUnicodeRendering: true;
			color: (Color gray: 0.2);
			contents: '0000000000000000';  "this sets the readout size"
			growable: false;
			stepTime: 100;
			position: (label right + 4)@y.

		ScratchTranslator isRTL ifTrue:[
			readout rightJustify: true].

		self addMorph: label; addMorph: readout.
		readoutMorphs add: label; add: readout.

		readout startStepping.
		x _ readout right + 2].

	ScratchTranslator isRTL ifTrue: [
		readoutMorphs reversed do: [: m |
			readoutMorphs remove: m.
			readoutMorphs add: m]].

	"penReadout _ Morph new extent: 15@5.
	penReadout position: (lockButton right + 4)@(nameMorph top + ((nameMorph height - penReadout height) / 2));
		color: Color transparent.
	self addMorph: penReadout.
	readoutMorphs add: penReadout.
	penReadout startStepping."

	readoutMorphs _ readoutMorphs asArray.
! !

!ScratchScriptEditorMorph methodsFor: 'private'!
showOrHideReadouts
	"If this is a sprite, show the position and direction readouts and the rotation style buttons. Otherwise, hide them."

	self deleteReadouts.

	nameMorph
		font: nameMorph font;
		width: nameMorph height * 4;
		rightJustify: ScratchTranslator isRTL.

	(self target isKindOf: ScratchSpriteMorph) ifTrue: [
		self addReadouts.
		World ifNotNil: [World startSteppingSubmorphsOf: self]].
! !

